//+------------------------------------------------------------------+
//|                                                  xde_blue_red.mq4 |
//|                                             Copyright  2009, Me |
//|                                           http://www.metecam.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, XDE"
#property link      "http://www.lara.hmarka.net"

//---- input parameters
extern int magic = 1001015;
extern double lot_=0.01;
extern int stop_loss_=280; //   
extern int take_profit_=120;  // 
int expertBars;
int peri = 1;  //      (1 - )
////////    
extern int MaMetod  = 1;
extern int MaPeriod = 3;
/////////
string IndicatorFileName = "Heiken_ashi_ma";
double ExtMapBuffer1;
double ExtMapBuffer2;
double ExtMapBuffer3;
double ExtMapBuffer4;
/////////
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);  
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0); 
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int go = 0;
   if (isNewBar()==false) return(0);  //     
   ExtMapBuffer1=iCustom(NULL,0,IndicatorFileName,MaMetod,MaPeriod,0,peri);
   ExtMapBuffer2=iCustom(NULL,0,IndicatorFileName,MaMetod,MaPeriod,1,peri);
   ExtMapBuffer3=iCustom(NULL,0,IndicatorFileName,MaMetod,MaPeriod,2,peri);
   ExtMapBuffer4=iCustom(NULL,0,IndicatorFileName,MaMetod,MaPeriod,3,peri);
   //1=5, 2=6, 3=7, 4=8
   //The logik
   // ex3<ex4 || ex1<ex2 = blue
   // ex1>ex2 || ex3>ex4 = red
   if (ExtMapBuffer3<ExtMapBuffer4 && ExtMapBuffer1<ExtMapBuffer2) 
   {
      if (SchOrders(OP_BUY)==0)
      {
         buy_();
         CloseSome(OP_SELL);
      }
   }
   if (ExtMapBuffer1>ExtMapBuffer2 && ExtMapBuffer3>ExtMapBuffer4)
   {
      if (SchOrders(OP_SELL)==0)
      {
         sell_();   
         CloseSome(OP_BUY);
      }
   }
   return(0); 
  }
//+------------------------------------------------------------------+

int buy_()
{
   int tn=0;
   tn = OrderSend(Symbol(),OP_BUY,lot_,Ask,2,Bid-stop_loss_*Point,Bid+take_profit_*Point,"fast pips",magic,0,CLR_NONE);
   if (tn<0)
      {
         Print (GetLastError());  
      }
   return(0);
}

//--------------------

int sell_()
{
   int tn=0;
   tn = OrderSend(Symbol(),OP_SELL,lot_,Bid,2,Ask+stop_loss_*Point,Ask-take_profit_*Point,"fast pips",magic,0,CLR_NONE);
   if (tn<0)
      {
         Print (GetLastError());  
      }
   return(0);
}

//---------------------

int SchOrders(int type) //- copied from ***ther ))
{
//       

int SchBuyStop=0; 
int SchSellStop=0; 
int SchBuyLimit=0; 
int SchBuy=0; 
int SchSell=0; 
int SchSellLimit=0;
for (int i=OrdersTotal()-1;i>=0;i--)
{// 
if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
{//    

if(OrderSymbol() !=Symbol())continue;
if(OrderMagicNumber() != magic)continue;

if(OrderType()==OP_BUYSTOP) 
SchBuyStop++;
if(OrderType()==OP_SELLSTOP) 
SchSellStop++; 
if(OrderType()==OP_SELLLIMIT)
SchSellLimit++;
if(OrderType()==OP_BUYLIMIT)
SchBuyLimit++;
if(OrderType()==OP_BUY) 
SchBuy++;
if(OrderType()==OP_SELL)
SchSell++;
}//    
}// 
if(type == OP_BUY) return(SchBuy);
if(type == OP_SELL)return(SchSell);
if(type == OP_BUYSTOP)return(SchBuyStop);
if(type == OP_SELLSTOP)return(SchSellStop);
if(type == OP_SELLLIMIT)return(SchSellLimit);
if(type == OP_BUYLIMIT)return(SchBuyLimit);
}

//-----------------------------

void CloseSome(int what) // OP_BUY = close buy, OP_SELL = close sell.
   {
   int result,error;
   double price;
   int cmd;

   for(int pos=OrdersTotal()-1; pos>=0; pos--)
      {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==false) {Print("   ");continue;}

      if(OrderSymbol() !=Symbol())continue;
      if(OrderMagicNumber() != magic)continue;

      cmd=OrderType();
      if(cmd == OP_BUY || cmd == OP_SELL)
         {
         while(true)
            {
            if(cmd!=what) break;
            if(cmd==OP_BUY) price=Bid;
            if(cmd==OP_SELL) price=Ask;
            result=OrderClose(OrderTicket(),OrderLots(),price,2,CLR_NONE);
            if(result!=TRUE) { error=GetLastError(); Print("LastError = ",error); }
            else error=0;
            if(error==135) RefreshRates();
            else break;
            } 
         }

      }
   }
   
bool isNewBar()
  {
   bool res=false; 
   if (expertBars!=Bars) 
      {
      expertBars=Bars;
      res=true;
      } 
   return(res);
  }
